import GaiKapadia.GaiKapadiaModel;
import simudyne.core.exec.runner.ModelRunner;
import simudyne.core.exec.runner.RunnerBackend;
import simudyne.core.exec.runner.definition.BatchDefinitionsBuilder;
import simudyne.core.exec.runner.definition.ModelSamplerDefinitionsBuilder;
import simudyne.nexus.Server;

public class Main {
  public static void main(String[] args) {
    boolean runHeadless = false;
    if(!runHeadless) {
      Server.register("Gai-Kapadia Model", GaiKapadiaModel.class);
      Server.run();
    } else {
      try {
        RunnerBackend runnerBackend = RunnerBackend.create();
        ModelRunner modelRunner = runnerBackend.forModel(GaiKapadiaModel.class);
        ModelSamplerDefinitionsBuilder runDefinitionsBuilder =
              ModelSamplerDefinitionsBuilder.create()
                      .forRuns(100)
                      .forTicks(40)
                      .forSamples(12)
                      .withListedDimension("nodeDegree2", 0.1, 1,2,3,4,5,6,7,8,9,10);

      modelRunner.forRunDefinitionBuilder(runDefinitionsBuilder);
      modelRunner.run();

      } catch (RuntimeException e) {
        e.printStackTrace();
      }
    }
  }
}
